#include "guimodule.h"
#include "windows.h"
#include <stdio.h>
#include <assert.h>

GuiModule::GuiModule(seGuiCallback seaudioMaster, void *p_resvd1) : SEGUI_base(seaudioMaster, p_resvd1)
{
	//draw_trace[0] = true;
	//draw_trace[1] = true;
	// clear values
	for( int i = SCOPE_BUFFER_SIZE ; i >=0 ; i-- )
	{
		values[0][i] = values[1][i] = 1000.f; // off-screen
	}

	CallHost(seGuiHostSetWindowSize, 100, 100 );
	CallHost(seGuiHostSetWindowType, 0 ); // 0 = Draw on SE's window (default), 1 = HWND based

//	CallHost(seGuiHostSetWindowFlags, HWF_RESIZEABLE|HWF_NO_CUSTOM_GFX_ON_STRUCTURE );
	CallHost(seGuiHostSetWindowFlags, HWF_RESIZEABLE );
}

/*
void GuiModule::Initialise(bool loaded_from_file)
{
	SEGUI_base::Initialise(loaded_from_file);

	CallHost(seGuiHostSetIdle, 1 );
}

bool GuiModule::OnIdle(void)
{
	int test = 9;
	return true;
}
*/
#define PN_ENUM_OUT 2

/*
void GuiModule::OnWindowOpen(SEWndInfo *wi)
{
	// get the full path of an imbedded file when you only know it's short name
	const int MAX_STRING_LENGTH = 300;

	// Both destination is UNICODE (two-byte) character string
	unsigned short dest[MAX_STRING_LENGTH];

	CallHost( seGuiHostPlugGetExtraData, PN_ENUM_OUT, MAX_STRING_LENGTH, &dest);

	// to convert to ascii
	char ascii_text[MAX_STRING_LENGTH];
	WideCharToMultiByte(CP_ACP, 0, dest, -1, ascii_text, MAX_STRING_LENGTH, NULL, NULL);


	// example of accessing the Window handle ( windowtype=1 only)
	HWND hWnd = (HWND) CallHost(seGuiHostGetWindowHandle, wi->context_handle );

RECT r;
	GetClientRect( hWnd, &r );
HWND hTextArea = CreateWindow( "edit", 
   NULL, WS_CHILD | ES_LEFT | WS_SIZEBOX | ES_MULTILINE | WS_VSCROLL,
   r.left, r.top, r.right - r.left, r.bottom - r.top, 
   hWnd, NULL,(HINSTANCE)Handle(), NULL );
ShowWindow( hTextArea, SW_SHOW );
}*/

/*

void GuiModule::OnWindowClose(SEWndInfo *wi)
{
}
*/

GuiModule::~GuiModule(void)
{
}

void GuiModule::paint( HDC hDC, SEWndInfo *wi )
{
/*/testing
	long parent_context = wi->context_handle;
	HWND h = 0;
	while( h == 0 )
	{
		parent_context = CallHost(seGuiHostGetParentContext, parent_context );
		h = (HWND) CallHost( seGuiHostGetWindowHandle, parent_context );
	}

	sepoint offset(0,0);
	CallHost(seGuiHostMapWindowPoints, wi->context_handle, parent_context, &offset, 0 );
*/


	HFONT font_handle = (HFONT) CallHost(seGuiHostGetFontInfo, wi->context_handle, (long) "tty", &m_font_info );

	float scale = wi->height / 2.15f;
	int mid_x = wi->width/2;
	int mid_y = wi->height/2;

	if( m_font_info.color_background >= 0 ) // -1 indicates transparent background
	{
		// Fill in solid background black
		HBRUSH background_brush = CreateSolidBrush( m_font_info.color_background );

		RECT r;
		r.top = r.left = 0;
		r.right = wi->width + 1;
		r.bottom = wi->height + 1;
		FillRect( hDC, &r, background_brush );

		// cleanup objects
		DeleteObject(background_brush);
	}

	// create a green pen
	int darked_col = (m_font_info.color >> 1 ) &0x7f7f7f;
	HPEN pen = CreatePen( PS_SOLID, 1, darked_col ); // dark green

	// 'select' it
	HGDIOBJ old_pen = SelectObject( hDC, pen );

	// BACKGROUND LINES
	// horizontal line
	MoveToEx(hDC, 0, mid_y, 0 );
	LineTo(hDC, wi->width, mid_y );
	// vertical line
	MoveToEx(hDC, mid_x, 0, 0 );
	LineTo(hDC, mid_x, wi->height );

	// voltage ticks
	int tick_width = 2;
	int step = 1;
	if( wi->height < 50 )
		step = 4;

	for( int v = -10 ; v < 11 ; v += step )
	{
		float y = v * scale / 10.f;
		
		if( v % 5 == 0 )
			tick_width = 4;
		else
			tick_width = 2;

		MoveToEx(hDC, mid_x - tick_width,mid_y + (int)y, 0 );
		LineTo(hDC, mid_x + tick_width,mid_y + (int)y );
	}

	// labels
	if( wi->height > 30 )
	{
		int font_height = m_font_info.font_height;

		HGDIOBJ old_font = SelectObject( hDC, font_handle );

		SetTextColor( hDC, m_font_info.color );
		SetBkMode( hDC, TRANSPARENT );
		SetTextAlign( hDC, TA_LEFT );

		for( int v = -10 ; v < 11 ; v += 5 )
		{
			char txt[10];
			float y = v * scale / 10.f;
			sprintf( txt, "%2.0f", (float) v );

			TextOut( hDC, mid_x + tick_width, mid_y - (int) y - font_height/2, txt, strlen(txt) );
		}
/*
		if( input_state_error_flag )
		{
			TextOut( hDC,0,0, "IN STATE ERR!" );
		}
*/
		SelectObject( hDC, old_font );
	}

	// clean up
	SelectObject( hDC, old_pen );
	DeleteObject( pen );

	// trace
	pen = CreatePen( PS_SOLID, 1, m_font_info.color );
	old_pen = SelectObject( hDC, pen );

	for(int chan = 0 ; chan < SCOPE_CHANNELS; chan++)
	{
		//if( draw_trace[chan] )
		{
			MoveToEx(hDC, 0, mid_y - (int) (values[chan][0] * scale), 0 );

			for( int i = 1 ; i < SCOPE_BUFFER_SIZE ; i++ )
			{
				int x = (i * wi->width) / SCOPE_BUFFER_SIZE;
				LineTo(hDC, x, mid_y - (int) (values[chan][i] * scale) );
			}
		}
		SelectObject( hDC, old_pen );
		DeleteObject( pen );

		// trace yellow
		pen = CreatePen( PS_SOLID, 1, RGB(250,250,0) ); // yellow
		old_pen = SelectObject( hDC, pen );
	}

	// cleanup
	SelectObject( hDC, old_pen );
	DeleteObject( pen );
}

void GuiModule::OnModuleMsg(int p_user_msg_id,int p_length, void * p_data)
{
#if defined( _DEBUG )
//	char *m = (char *)p_data;
//	if( m[0] == 't' && m[1] == 'e' && m[2] == 's' && m[3] == 't' )
	if( p_user_msg_id == id_to_int('t','e','s','t') )
	{
		const int sz = 300000;
		unsigned char *test_data = (unsigned char *)p_data;
		for( int i = 0 ; i < sz ; i++ )
		{
			assert( test_data[i] == (i & 0xff) );
		}
		return;
	}
#endif

	assert( p_length == sizeof(values) );
	memcpy(values,p_data,p_length);

	// aknowledge

//	char *msg = "ack";
//	int size = 4;
/*
	char *msg =  "ack00000000000000000000000000000000000000000000000"
		         "11111111111111111111111111111111111111111111111111"
				 "22222222222222222222222222222222222222222222222222"
				 "22222222222222222222222222222222222222222222222222"
				 "22222222222222222222222222222222222222222222222222"
				 "22222222222222222222222222222222222222222222222222"
				 "22222222222222222222222222222222222222222222222222"
				 "22222222222222222222222222222222222222222222222222"
				 "33333333333333333333333333333333333333333333333333"
				 "44444444444444444444444444444444444444444444444444"
				 "55555555555555555555555555555555555555555555555555"
				 "66666666666666666666666666666666666666666666666666"
				 "66666666666666666666666666666666666666666666666666"
				 "66666666666666666666666666666666666666666666666666"
				 "66666666666666666666666666666666666666666666666666"
				 "77777777777777777777777777777777777777777777777777"
				 "88888888888888888888888888888888888888888888888888";
	int size = strlen( msg ) + 1;
*/

	// send aknowledge message to DSP
	SendStringToAudio( id_to_int('a','c','k',0), 0, 0 );

	InvalidateControl();
}

void GuiModule::SendStringToAudio( int p_msg_id, int p_length, void *p_data )
{
	CallHost(seGuiHostSendStringToAudio, p_length, p_msg_id, p_data );
}

int GuiModule::Handle(void)
{
	return CallHost(seGuiHostGetHandle);
}

int GuiModule::InvalidateControl(void)
{
	return CallHost(seGuiHostRequestRepaint);
}



