#include "smart_output.h"
#include "SEModule_base.h"
#include "SEPin.h"

smart_output::smart_output(SEModule_base *p_module, int p_plug_number) :
m_current_output_value(0.f)
,output_buffer_ptr(0)
,m_module(p_module)
,m_pin_number(p_plug_number)
,static_output_count(200) // to be safe
{
}

smart_output::~smart_output(void)
{
}

void smart_output::process( int buffer_position, int sampleframes)
{
	if( static_output_count < 0 )
		return;

	if( static_output_count < sampleframes ) // lazy as posible
	{
		sampleframes = static_output_count;
	}

	float *out = output_buffer_ptr + buffer_position;
	for( int i = sampleframes ;  i > 0 ; i-- )
	{
		*out++ = m_current_output_value;;
	}

	static_output_count -= sampleframes;
}

void smart_output::SetValue(unsigned int p_sample_clock, float p_newvalue)
{
	if( m_current_output_value != p_newvalue )
	{
		static_output_count = m_module->getBlockSize();
		m_current_output_value = p_newvalue;
		m_module->getPin(m_pin_number)->TransmitStatusChange( p_sample_clock, ST_ONE_OFF );
	}
}
