#include "guimodule.h"
#include "it_enum_list.h"

#define PN_IN 0
#define PN_OUT 1
#define PN_MODE 2

GuiModule::GuiModule(seGuiCallback seaudioMaster, void *p_resvd1) : SEGUI_base(seaudioMaster, p_resvd1)
{
}

/* testing
void GuiModule::Initialise(bool loaded_from_file)
{
	SEGUI_base::Initialise(loaded_from_file);
	int i = getPin(PN_IN)->IsConnected();
	i = getPin(PN_OUT)->IsConnected();
}
*/
void GuiModule::OnGuiPinValueChange(SeGuiPin *p_pin)
{
	//int i = getPin(PN_IN)->IsConnected();
	//i = getPin(PN_OUT)->IsConnected();

	int mode = getPin(PN_MODE)->getValueInt();

	switch( p_pin->getIndex() )
	{
		case PN_IN:
		case PN_MODE:
		{
			int in_val = getPin(PN_IN)->getValueInt();
			if( mode == 0 ) // calc what value this index maps to
			{
				it_enum_list it( getPin(PN_OUT)->getExtraData() );
				it.First();
				while( !it.IsDone() && (*it)->index != in_val )
				{
					++it;
				}
				if( !it.IsDone() )
				{
					_RPTW2(_CRT_WARN, L"%d->%d\n", in_val, (*it)->value );
					getPin(PN_OUT)->setValueInt( (*it)->value );
				}
			}
			else
			{
				_RPTW1(_CRT_WARN, L"PN_OUT->%d\n", in_val );
				getPin(PN_OUT)->setValueInt( in_val );
			}
		}
		break;
		case PN_OUT:
		{
			int out_val = getPin(PN_OUT)->getValueInt();
			if( mode == 0 ) // calc what index this value maps to
			{
				it_enum_list it( getPin(PN_OUT)->getExtraData() );
				it.First();
				while( !it.IsDone() && (*it)->value != out_val )
				{
					++it;
				}
				if( !it.IsDone() )
				{
					_RPTW2(_CRT_WARN, L"%d<-%d\n", (*it)->index, out_val );
					getPin(PN_IN)->setValueInt( (*it)->index );
				}
			}
			else
			{
				_RPTW1(_CRT_WARN, L"PN_IN->%d\n", out_val );
				getPin(PN_IN)->setValueInt(out_val);
			}
		}
		break;
	}
}




