#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

struct se_blob
{
	int size;
	void *data;
};

#define SCOPE_BUFFER_SIZE 100
#define CHANNELS 2
typedef FSAMPLE scope_results[CHANNELS][104];

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

//	virtual bool getModuleProperties (SEModuleProperties* properties);
	static void getModuleProperties(SEModuleProperties* properties);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleframes );
	void SE_CALLING_CONVENTION sub_process_cruise(long buffer_offset, long sampleframes );
	void SE_CALLING_CONVENTION WaitForTrigger1(long buffer_offset, long sampleframes );
	void SE_CALLING_CONVENTION WaitForTrigger2(long buffer_offset, long sampleframes );
//	void OnPlugStateChange(SEPin *pin);
	void OnGuiNotify( int p_user_msg_id, int p_size, void *p_data );
	virtual void open();

private:
	void SendStringToGui( int p_msg_id, int p_length, unsigned char *p_data );
	void ForceTrigger();
#if defined( _DEBUG )
	void TestQue();
#endif
	void send_result_to_gui();
	float *input_ptr1; // pointer to circular buffer of samples
	float *input_ptr2;
	int m_idx;
	int timeout;
	bool m_gui_busy;
	scope_results m_results;
	bool m_channel_active[CHANNELS];
	se_blob m_results_blob;
};
#endif
