#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"
#include "GuiModule.h"

// define what type you want to share. (256 sample waveform, in 10 band-limited versions)
//typedef float myArrayType[10][256];

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleframes );
	void SE_CALLING_CONVENTION sub_process_static(long buffer_offset, long sampleframes );
	virtual void open();
	void OnPlugStateChange(SEPin *pin);
	void ChooseProcess();

private:
//	char* myArrayRawPointer;

	bool CreateSharedLookup( char *p_table_name, void *p_table_pointer, float p_sample_rate, int p_size);
	void SetupLookupTable();
	void FillLookupTable();
	void OnLookupTableChanged();
	int Handle(void);
	float *in1_ptr; // pointer to circular buffer of samples
	float *out1_ptr;
	char *shape_ptr;
	int static_count;
	float *m_lookup_table;
};
#endif
